VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AnyShape"
   ClientHeight    =   4260
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6465
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4260
   ScaleWidth      =   6465
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Instructions"
      Height          =   375
      Left            =   5040
      TabIndex        =   8
      Top             =   3720
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   5040
      Top             =   2760
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
      CancelError     =   -1  'True
   End
   Begin VB.PictureBox Picture2 
      BackColor       =   &H00000000&
      Height          =   255
      Left            =   6000
      ScaleHeight     =   195
      ScaleWidth      =   195
      TabIndex        =   7
      Top             =   1080
      Width           =   255
   End
   Begin VB.OptionButton Option2 
      Caption         =   "Alternate"
      Height          =   255
      Left            =   5040
      TabIndex        =   5
      Top             =   720
      Width           =   1215
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Winding"
      Height          =   255
      Left            =   5040
      TabIndex        =   4
      Top             =   480
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Clear"
      Height          =   375
      Left            =   5040
      TabIndex        =   3
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Show"
      Height          =   375
      Left            =   5040
      TabIndex        =   2
      Top             =   1440
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   3615
      Left            =   120
      ScaleHeight     =   3555
      ScaleWidth      =   4755
      TabIndex        =   0
      Top             =   480
      Width           =   4815
   End
   Begin VB.Label Label2 
      Caption         =   "BackColor"
      Height          =   255
      Left            =   5040
      TabIndex        =   6
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Draw the Shape Here"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Points() As POINTDATA
Dim NumPoints As Long
Dim PolyRegion As Long
Dim ReturnVal As Long
Dim Method As Long

Private Sub Command1_Click()
    If NumPoints < 2 Then
        MsgBox "At least 3 points are needed."
        Exit Sub
    End If
    Load frmTest
    'Set the fill method
    'WINDING-Fills overlapping regions
    'ALTERNATE-Doesn't fill overlapping regions
    'Try drawing a pentagon to see the difference between the two methods.
    If Option1.Value Then Method = WINDING Else Method = ALTERNATE
    'Create the Region using predefined points
    PolyRegion = CreatePolygonRgn(Points(0), NumPoints + 1, Method)
    'Set the window region of our form
    ReturnVal = SetWindowRgn(frmTest.hWnd, PolyRegion, True)
    frmTest.BackColor = Picture2.BackColor
    frmTest.Show
End Sub

Private Sub Command2_Click()
    'Clear the picture box and point data
    ReDim Points(0)
    NumPoints = -1
    Picture1.Cls
    Unload frmTest
End Sub

Private Sub Command3_Click()
    msgstr = "Draw on the picturebox on the left. Each click of the mouse" & vbNewLine _
    & "represents a new point of the polygon that will form the window." & vbNewLine & vbNewLine _
    & "'Winding' and 'Alternate' option buttons determine the fill method" & vbNewLine _
    & "that will be used for the intersecting regions." & vbNewLine & vbNewLine _
    & "You can select the background color of the window by clicking" & vbNewLine _
    & "on the box near the 'Background' label." & vbNewLine & vbNewLine _
    & "Click the 'Show' button to show the window. 'Clear' button hides" & vbNewLine _
    & "the window and clears the picturebox." & vbNewLine & vbNewLine _
    & "You can move the window by holding down the left mouse button" & vbNewLine _
    & "and hide it by pressing the right mouse button."
    MsgBox msgstr
End Sub

Private Sub Form_Load()
    NumPoints = -1
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload frmTest
End Sub

Private Sub Option1_Click()
    Option2.Value = False
End Sub

Private Sub Option2_Click()
    Option1.Value = False
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Increase the number of points
    NumPoints = NumPoints + 1
    ReDim Preserve Points(NumPoints)
    'Add the new point to the Point data
    Points(NumPoints).X = X / Screen.TwipsPerPixelX
    Points(NumPoints).Y = Y / Screen.TwipsPerPixelY
    'Draw the new point ob the picturebox.
    If NumPoints = 0 Then Picture1.PSet (X, Y)
    Picture1.Line -(X, Y)
End Sub

Private Sub Picture2_Click()
    On Error Resume Next
    CommonDialog1.ShowColor
    If Err.Number <> 0 Then Exit Sub
    'Set form backcolor
    frmTest.BackColor = CommonDialog1.Color
    Picture2.BackColor = CommonDialog1.Color
    Picture1.ForeColor = CommonDialog1.Color
    If frmTest.Visible Then frmTest.Show
End Sub
